import java.io.*;
import java.util.*;
import java.awt.*;
import java.net.*;
import java.applet.*;

/** Author Randy Levensalor
  * Version 1.0
  * Based of builder 1.1 written by Dennis Seay
*/

public class BuilderViewer extends Applet
{
BufferedReader is = null;
String header = "";
Panel form;
        public final static String END_OF_NODE = "<--END-NODE-->";
        public final static String BEGIN_NODE_DATA = "<--BEGIN-NODE-DATA-->";
        public final static String END_NODE_DATA = "<--END-NODE-DATA-->";
/** Main Constructor
*/
  public void init ( )
  {
	URL url;
	String fileName = getParameter("file");	
	try { url = new URL(fileName);

	is = new BufferedReader(new InputStreamReader(url.openStream()));}
	    catch(IOException e) { e.printStackTrace(); }
	form = new Panel();
	loadNode();
	loadLocation();
  }

/** closeLoadFile
  * This function closes any open files that were being loaded to.
*/
  public void closeLoadFile()
  {
	 try { is.close(); }
	    catch(IOException e) { e.printStackTrace(); }
  }


/** readDimension
  * This function returns a Dimension
*/
Dimension readDimension() throws IOException
{
  int height = 0;
  int width  = 0;
  String line = "";
  Dimension dimension = null;

  line = is.readLine();
  StringTokenizer s = new StringTokenizer(line);

  height = (new Integer(s.nextToken())).intValue();
  width = (new Integer(s.nextToken())).intValue();
  //System.out.println("Save x: " + x + "Save y: " + y);
  dimension = new Dimension(width,height);
  return dimension;
}

/** readPoint
  * This function returns a point
*/
Point readPoint() throws IOException
{
  int x = 0;
  int y = 0;
  String line = "";
  Point point = null;

  line = is.readLine();
  StringTokenizer s = new StringTokenizer(line);

  x = (new Integer(s.nextToken())).intValue();
  y = (new Integer(s.nextToken())).intValue();
  //System.out.println("Save x: " + x + "Save y: " + y);
  point = new Point(x,y);
  return point;
}

/** loadNode
  * This function loads the information to recreate a node.
*/

  public void loadNode()
  {
    String nodeType = "";
    String name = "";
    String mode;  //is only used for trash
    Point nodeLoc =null;
    Point labelLoc=null;
    boolean visible;
    
    try {
      header = is.readLine();

      if(!header.equals(BEGIN_NODE_DATA))
      {
        System.out.println("Error: invalid file format");
        return;
      }

      header = END_OF_NODE;
      while(header.equals(END_OF_NODE))
      {
        nodeType = is.readLine();
        if(nodeType.equals(END_NODE_DATA))
        {
          return;
        }
        try {nodeLoc =  readPoint();}
	    catch(IOException e) { e.printStackTrace(); }
        name = is.readLine();
        try {labelLoc = readPoint();}
	    catch(IOException e) { e.printStackTrace(); }
        visible = (new Boolean(is.readLine())).booleanValue();
        mode = is.readLine();
        mode = is.readLine();
        mode = is.readLine();
        createNode(nodeType,name,nodeLoc,labelLoc);
      }
    }catch (IOException e)
    { System.out.println("Error: can not load file"); }

  }

  void createNode(String nodeType, String name, Point nodeLoc, Point labelLoc) throws IOException
  {

    if(nodeType.equals("ButtonNode"))
    {
      Button b = new Button(name);
      b.setLabel(is.readLine());
      header = is.readLine();
      form.add(b);
      b.reshape(nodeLoc.x,nodeLoc.y,60,30);
    }
//not ready yet
/*    else if(nodeType.equals("MailToNode"))
    {
      mail = new MailToNode(name,workSpace,iconLoc,form);
      ((MailToNode)n).setMailServer(is.readLine());
      ((MailToNode)n).setUserID(is.readLine());
      ((MailToNode)n).setSendTo(is.readLine());
      ((MailToNode)n).setPort((new Integer(is.readLine())).intValue());
      header = is.readLine();
    }

/*not going to be done for a bit
    else if(nodeType.equals("PullDownNode"))
    {
      String nextData = "";
      n = new PullDownNode(name,workSpace,iconLoc,form);
      nextData = is.readLine();
      while(!nextData.equals(Node.END_OF_NODE))
      {
        ((Choice)n.getComponent()).addItem(nextData);
        nextData = is.readLine();
      }
      header = nextData;
    }

    else if(nodeType.equals("SliderNode"))
    {
      n = new SliderNode(name,workSpace,iconLoc,form);
      ((Scrollbar)n.getComponent()).setValue((new Integer(is.readLine())).intValue());
      ((SliderNode)n).setMin((new Integer(is.readLine())).intValue());
      ((SliderNode)n).getMinLabel().setPoint(readPoint());
      if(is.readLine().equals("false"))
      {
        System.out.println("false");
        ((SliderNode)n).getMinLabel().setVisible(false);
        ((SliderNode)n).getMaxLabel().setVisible(false);
      }
      ((SliderNode)n).setMax((new Integer(is.readLine())).intValue());
      ((SliderNode)n).getMaxLabel().setPoint(readPoint());
      if(is.readLine().equals("false"))
      {
        ((SliderNode)n).getMinLabel().setVisible(false);
        ((SliderNode)n).getMaxLabel().setVisible(false);

      }
      header = is.readLine();
    }
*/
    else if(nodeType.equals("TextFieldNode"))
    {
       TextField tf = new TextField(name);
       //need to add support for output field

       tf.setText(is.readLine());
       form.add(tf);
       tf.setLocation(nodeLoc.x,nodeLoc.y);
       header = is.readLine();
    }
  }

  public void loadLocation(){
	try {form.setLocation(readPoint());}
	    catch(IOException e) { e.printStackTrace(); }
	try {form.setSize( readDimension());}	
	    catch(IOException e) { e.printStackTrace(); }
  }
}
