package builder;

import java.awt.event.*;

/** Creates the Window event listener for the builder class.
    * @author Dennis Seay
    * @version 1.1 07/97
*/

public class BuilderWindowListener extends WindowAdapter implements WindowListener
{
	
  Builder parent = null;
 
/** Creates the Window event listener for the builder class.
  * @param p is the instance of builder that this listner will work on.
*/
 
  public BuilderWindowListener(Builder p)
  {
    parent = p;
  }

/** Calls the closeWindowHelper function in builder.
  * @param e is the event that occured.
*/

  public void windowClosed(WindowEvent e)
  {
    parent.closeWindowHelper();
  }
}
