package builder;

import java.awt.event.*;


/**     This class is an action listener for attributes
        * @author Dennis Seay
        * @version 1.1 07/97
*/

public class ChangeAttributesActionListener implements ActionListener
{
	
  ChangeAttributes parent = null;

/** Constructortes a actionListener
  * @param p is the objected that created the listener.
*/  
  public ChangeAttributesActionListener(ChangeAttributes p)
  {
    parent = p;
  }

/** actionPerformed
  * This function determines which action has occured and tells
  * the parent how to handle that action.
  * @param e is the event that occured.
*/
  public void actionPerformed(ActionEvent e)
  {
    int    actionMode   = parent.getActionMode();
    System.out.println("Event: " + e.getActionCommand());
    System.out.println("ActionEvent: " + actionMode);

    switch(actionMode)
    {
      case parent.BUTTON_NAME_ACTION:
      {
        parent.buttonAction();
        break;
      }
      case parent.TEXT_ACTION:
      {
        parent.tfieldAction();
        break;
      }
      case parent.PDMENU_ADD_ACTION:
      {
        parent.pdMenuAction();
        break;
      }
      case parent.NAME_ACTION:
      {
        parent.nameAction();
        break;
      }
      case parent.MIN_VAL_ACTION:
      {
        parent.minAction();
        break;
      }
      case parent.MAX_VAL_ACTION:
      {
        parent.maxAction();
        break;
      }
      case parent.MAIL_SERVER_ACTION:
      {
        parent.mailServerAction();
        break;
      }
      case parent.USER_ID_ACTION:
      {
        parent.userIDAction();
        break;
      }
      case parent.SEND_TO_ACTION:
      {
        parent.sendToAction();
        break;
      }
      case parent.PORT_ACTION:
      {
        parent.portAction();
        break;
      }
    }
  }
}
