package builder;


import java.awt.event.*;
import java.awt.*;

/**     This class Listens for attribute events
        * @author Dennis Seay
        * @version 1.1 07/97
*/

public class ChangeAttributesItemListener implements ItemListener

{

  ChangeAttributes parent   = null;
  Choice           pullDown = null;

/** Constructortes a itemListener
  * @param p is the objected that created the listener.
*/

  public ChangeAttributesItemListener(ChangeAttributes p)
  {
    parent = p;
    pullDown = parent.getChoice();
  }


/** itemStateChanged
  * This function determines which action was selected and
  * tells the parent how to respond to the new attribute.
  * @param e is the event that occured.
*/
  public void itemStateChanged(ItemEvent e)
  {
    String command;
    command = (String) e.getItem();

    parent.remove(pullDown);

    if (command.equals(parent.NAME))
    {
      parent.setAction(parent.NAME_ACTION);
      parent.changeNameHelper();
    }else if (command.equals(parent.HIDE_NAME))
    {
      parent.hideName();
    }else if (command.equals(parent.SHOW_NAME))
    {
      parent.showName();
    }else if ( command.equals(ChangeAttributes.TEXT) )
    {
      parent.setAction(parent.TEXT_ACTION);
      parent.setTFieldText();
    }else if( command.equals(ChangeAttributes.ADD)    )
    {
      parent.setAction(parent.PDMENU_ADD_ACTION);
      parent.addPDMenuItem();
    }else if( command.equals(ChangeAttributes.BUTTON_NAME) )
    {
      parent.setAction(parent.BUTTON_NAME_ACTION);
      parent.buttonName();
    }else if( command.equals(ChangeAttributes.MIN_VALUE))
    {
      parent.setAction(parent.MIN_VAL_ACTION);
      parent.minValue();
    }else if(command.equals(ChangeAttributes.MAX_VALUE))
    {
      parent.setAction(parent.MAX_VAL_ACTION);
      parent.maxValue();
    }else if (command.equals(parent.HIDE_RANGE))
    {
      parent.hideRange();
    }else if (command.equals(parent.SHOW_RANGE))
    {
      parent.showRange();
    }else if(command.equals(parent.MAIL_SERVER))
    {
      parent.setAction(parent.MAIL_SERVER_ACTION);
      parent.mailServer();
    }else if(command.equals(parent.USER_ID))
    {
      parent.setAction(parent.USER_ID_ACTION);
      parent.userID();
    }else if(command.equals(parent.SEND_TO))
    {
      parent.setAction(parent.SEND_TO_ACTION);
      parent.sendTo();
    }else if(command.equals(parent.PORT))
    {
      parent.setAction(parent.PORT_ACTION);
      parent.port();
    }else if(command.equals(parent.DELETE_NODE))
    {
      parent.setAction(parent.DELETE_NODE_ACTION);
      parent.deleteNode();
    }

  }
}
