package builder;

import java.awt.*;
import java.awt.event.*;
import java.io.*;


/**	Creates the Form window for the builder interface.
	* @author Arturo Falck
	* @author Dennis Seay
	* @version 1.1 07/97
*/

public class FormSpace extends MyFrame {



// ********************* CONSTRUCTORS


/**	Main Constructor.
	* The form and the workspace are created when this class is constructed.
*/
public FormSpace (Map F)
{
  super("Demo: FORM");

  F.setBackground(Color.lightGray);
  F.setBounds( 10, 50, 465, 200 );

  initForm(F);
}

/** initForm
  * This function sets the size, layout and location of the userd form.
  * @param F is the form map.
*/

private void initForm(Map F)
{
  setLayout(null);
  setSize(465, 250);
  setLocation(100, 100);
  setLayout(new BorderLayout());
  add("Center", F);
  setVisible(true);

}

/** save
  * This function writes the location and size of the form
  * @param os is the the output stream to write the data to.
*/
  public void save(PrintWriter os)
  {
    Point p = getLocation();
    Dimension d = getSize();

    os.println(p.x + " " + p.y);
    os.println(d.height + " " + d.width);
  }

}

