package builder;
import java.awt.event.*;
import java.awt.*;

/**     This class creates a mouse listener for an icon
        * @author Dennis Seay
        * @version 1.1 07/97
*/


public class IconMouseListener extends MoveableMouseListener
{

/** Constructortes a mouseListener
  * @param p is the objected that created the listener.
*/
  public IconMouseListener(Moveable p)
  {
    super(p);
  }
/* mousePressed
  * This handles the case the wire button has been pressed
  * @param e is the event that occured
*/
 
  public void mousePressed(MouseEvent e)
  {
    int currentStatus = parent.getMouseStatus();
    if(currentStatus == parent.IGNORE_MOUSE)
    {
    }else if(currentStatus == parent.WIRING_MOUSE)
    {
      switch(e.getModifiers())
      {    
        case e.BUTTON1_MASK:  // Win95/NT
        case NO_MODIFIER:
        {
          currentModifier = NO_MODIFIER;
          ((Icon)parent).wiringLeftButtonPressed();
          break;
        }
        default:
        {
          super.mousePressed(e);
        }
      }  
    }else // Handle unspecified event type
    {
      super.mousePressed(e);
    }
  } 


/* mouseRealsed
  * This handles the icon mouse released events.
  * @param e is the event that occured
*/

  public void mouseReleased(MouseEvent e)
  {
    int currentStatus = parent.getMouseStatus(); 
    if(currentStatus == parent.IGNORE_MOUSE)   
    {  
    }else if(currentStatus == parent.WIRING_MOUSE) 
    {  
      switch(currentModifier)
      {    
        case e.BUTTON1_MASK:  // Win95/NT
        case NO_MODIFIER:
        { 
          currentModifier = NO_MODIFIER;
          ((Icon)parent).wiringLeftButtonReleased();
          break;
        }
        default:
        {
          super.mouseReleased(e);
        }
      }  
    }else // Handle unspecified event type 
    {
      super.mouseReleased(e);
    }

    currentModifier = NO_MODIFIER;
  }

/* mouseClicked
  * This handles the right click case for an icon if it is not a right
  * click it is passed to its super class.
  * @param e is the event that occured
*/

  public void mouseClicked(MouseEvent e)
  {
    int currentStatus = parent.getMouseStatus();
    if(currentStatus == parent.NORMAL_MOUSE)
    {
      switch(e.getModifiers())
      {  
        case e.META_MASK:
        //case e.BUTTON3_MASK: // This is the same as META_MASK
        {
          ((Icon)parent).rightMouseClick();
          break;
        }
        default:
        {
          super.mouseClicked(e);
          break;
        }
      }  
    }else // Handle unspecified event type
    {
          super.mouseClicked(e);
    }
 
  }

}
