package builder;

import java.awt.*;




/**	Modified Icon that includes an representation for Input.
	* @version 1.1 07/97
	* @author Arturo Falck
*/
public class InputIcon extends Icon{



// ********************* CONSTRUCTORS


/**	Main Constructor.
	* @param label name associated with the Icon.
	* @param m the Map where the Icon is placed.
	* @param l initial location of the Icon in the Map.
	* @param n The Node to which this Icon belongs.
*/
	public InputIcon (String label, Map m, Point l, Node n){
		super (label, m, l, n);
	}

/**	Constructor.
	* @param m the Map where the Icon is placed.
	* @param l initial location of the Icon in the Map.
*/
	public InputIcon (Map m, Point l) {
		this("Label", m, l, null);
	}

/**	Constructor.
	* @param m the Map where the Icon is placed.
*/
	public InputIcon (Map m) {
		this(m, new Point(1,1));
	}



// ********************* METHODS


/**	paint
	Refines the icon for the map representation of this Node.
	* @param g the graphics context.
*/
	public void paint (Graphics g) {
		g.setColor(Color.red);
		super.paint(g);
		g.drawString("I", 15, 16);
	}



// ********************* FIELDS


}
