package builder;
import java.awt.event.*;
import java.awt.*;

/**     This class allows a node to change the default actions.
        * @author Dennis Seay
        * @version 1.1 07/97
*/


public class MapMouseListener extends MouseAdapter
{
               Map      parent = null;
  static       int      currentModifier = 0;
  static final int      NO_MODIFIER = 0; 

/** Constructor
  * creates a mouseListener
  * @param p is the objected that created the listener.
*/


  public MapMouseListener(Map p)
  {
    parent = p;
  }


/* mouseRealsed
  * This handles the case that a moveable becomes stationary but the cursor is
  * outside the objects bounds. 
  * @param e is the event that occured
*/

  public void mouseReleased(MouseEvent e)
  {
    switch(currentModifier)
    {   
      case e.ALT_MASK:  
      //case e.BUTTON2_MASK:  // This is the same as ALT_MASK  
      {  
        currentModifier = e.ALT_MASK; 
        break;  
      }  
      case e.META_MASK:   
      //case e.BUTTON3_MASK: // This is the same as META_MASK    
      {  
        currentModifier = e.META_MASK;  
        break;  
      }  
      case e.CTRL_MASK:   
      { 
        currentModifier = e.CTRL_MASK;  
        break;  
      } 
      case e.SHIFT_MASK:  
      {  
        currentModifier = e.SHIFT_MASK; 
        break;  
      }  
      case NO_MODIFIER:   
      case e.BUTTON1_MASK: // for Win95/NT
      { 
        currentModifier = NO_MODIFIER;  
        if(parent.isMoving())
        {
          parent.leftButtonReleased(e.getX(),e.getY());
        }
        break;  
      } 
    }

    currentModifier = NO_MODIFIER;
  }
}
