package builder;
import java.awt.event.*;
import java.awt.*;

/**     This class allows a node to change the default actions.
        * @author Dennis Seay
        * @version 1.1 07/97
*/


public class MapMouseMotionListener extends MouseMotionAdapter 
{
                  Map      parent      = null;
  static final    int      NO_MODIFIER = 0;

/** Constructor
  * creates a mousemouseListener
  * @param p is the objected that created the listener.
*/


  public MapMouseMotionListener(Map p)
  {
    parent = p;
  }

/** mouseDragged
  * This classes handles events that are generated while moving a 
  * moveable icon but the cursor went outside the icons range.
  * @param e is the event that occured
*/

  public void mouseDragged(MouseEvent e)
  {
    switch(e.getModifiers()) 
    {   
      case e.ALT_MASK: 
      //case e.BUTTON2_MASK:  // This is the same as ALT_MASK 
      { 
        break;  
      } 
      case e.META_MASK: 
      //case e.BUTTON3_MASK: // This is the same as META_MASK 
      { 
        break;  
      } 
      case e.CTRL_MASK: 
      { 
        break;  
      } 
      case e.SHIFT_MASK: 
      { 
        break; 
      } 
      case e.BUTTON1_MASK: 
      { 
        if(parent.isMoving())
        {
          parent.leftMouseDragged(e.getX(),e.getY()); 
        }
        break;  
      }
      default: System.out.println("Event <" + e.getModifiers() + ">"); 
    }
  }
}
