package builder;
import java.awt.event.*;
import java.awt.*;

/**     This class catches mouse events.
        * @author Dennis Seay
        * @version 1.1 07/97
*/


public class MoveableMouseListener extends MouseAdapter implements MouseListener
{
               Moveable parent = null;
  static       int      currentModifier = 0;
  static final int      NO_MODIFIER = 0; 


/** Constructor
  * creates a mouseListener
  * @param p is the objected that created the listener.
*/

  public MoveableMouseListener(Moveable p)
  {
    parent = p;
  }

/** mousePressed
  * handles events that the mouse is pressed 
  * @param e is the event
*/
 
  public void mousePressed(MouseEvent e)
  {
    int currentStatus = parent.getMouseStatus();
    if(currentStatus == parent.IGNORE_MOUSE)
    {
    }else if(currentStatus == parent.WIRING_MOUSE)
    {
    }else if(currentStatus == parent.MOVING_MOUSE)
    {
    }else if(currentStatus == parent.NORMAL_MOUSE)
    {
      switch(e.getModifiers())
      {
        case e.ALT_MASK:
        //case e.BUTTON2_MASK:  // This is the same as ALT_MASK
        {
          currentModifier = e.ALT_MASK;
          break;
        }
        case e.META_MASK:
        //case e.BUTTON3_MASK: // This is the same as META_MASK
        {
          currentModifier = e.META_MASK;
          break;
        }
        case e.CTRL_MASK:
        {
          currentModifier = e.CTRL_MASK;
          break;
        }
        case e.SHIFT_MASK:
        {
          currentModifier = e.SHIFT_MASK;
          break;
        }
        case e.BUTTON1_MASK:  // for Win95/NT
        case NO_MODIFIER:
        {
          currentModifier = NO_MODIFIER;
          parent.leftButtonPressed(e.getX(),e.getY());
          break;
        }
      }
    }else // Handle unspecified event type
    {
    }
  } 


/** mouseReleased
  * handles events that the mouse is released
  * @param e is the event
*/

  public void mouseReleased(MouseEvent e)
  {
    int currentStatus = parent.getMouseStatus(); 
    if(currentStatus == parent.IGNORE_MOUSE)   
    {  
    }else if(currentStatus == parent.WIRING_MOUSE) 
    {  
    }else if(currentStatus == parent.MOVING_MOUSE) 
    {  
      switch(currentModifier)
      {   
        case e.ALT_MASK:  
        //case e.BUTTON2_MASK:  // This is the same as ALT_MASK  
        {  
          currentModifier = e.ALT_MASK; 
          break;  
        }  
        case e.META_MASK:   
        //case e.BUTTON3_MASK: // This is the same as META_MASK    
        {  
          currentModifier = e.META_MASK;  
          break;  
        }  
        case e.CTRL_MASK:   
        { 
          currentModifier = e.CTRL_MASK;  
          break;  
        } 
        case e.SHIFT_MASK:  
        {  
          currentModifier = e.SHIFT_MASK; 
          break;  
        }  
        case e.BUTTON1_MASK:  // for Win95/NT
        case NO_MODIFIER:   
        { 
          currentModifier = NO_MODIFIER;  
          parent.leftButtonReleased(); 
          break;  
        } 
      }
    }else if(currentStatus == parent.NORMAL_MOUSE) 
    {  
    }else // Handle unspecified event type 
    {
    }

    currentModifier = NO_MODIFIER;
    //System.out.println("x: " +e.getX() + " Y: " + e.getY());
  }
}
