package builder;
import java.awt.event.*;
import java.awt.*;

/**     This class listens for mouse events
        * @author Dennis Seay
        * @version 1.1 07/97
*/


public class MoveableMouseMotionListener extends MouseMotionAdapter implements MouseMotionListener
{
                  Moveable parent      = null;
  static final    int      NO_MODIFIER = 0;

/** Constructor
  * creates a moveableMouseListener
  * @param p is the objected that created the listener.
*/

  public MoveableMouseMotionListener(Moveable p)
  {
    parent = p;
  }

/* mouseDragged
  * This function handles the dragging evenets for moveable objects
  * @param e is the event that occured
*/
 
  public void mouseDragged(MouseEvent e)
  {
    int currentStatus = parent.getMouseStatus();
    if(currentStatus == parent.IGNORE_MOUSE)
    {
    }else if(currentStatus == parent.WIRING_MOUSE)
    {
    }else if(currentStatus == parent.MOVING_MOUSE)
    {
      switch(e.getModifiers()) 
      {   
        case e.ALT_MASK: 
        //case e.BUTTON2_MASK:  // This is the same as ALT_MASK 
        { 
          break;  
        } 
        case e.META_MASK: 
        //case e.BUTTON3_MASK: // This is the same as META_MASK 
        { 
          break;  
        } 
        case e.CTRL_MASK: 
        { 
          break;  
        } 
        case e.SHIFT_MASK: 
        { 
          break; 
        } 
        case e.BUTTON1_MASK: 
        case NO_MODIFIER: // for Win95/NT
        { 
          parent.leftMouseDragged(e.getX(),e.getY()); 
          //System.out.println("Location: " + e.getX() + "  " + e.getY());
          break;  
        }
        default: System.out.println("Event <" + e.getModifiers() + ">"); 
      }  
    }else if(currentStatus == parent.NORMAL_MOUSE)
    {
      // this should never occur
    }else // Handle unspecified event type 
    {
    }
    //System.out.println("Location: " + e.getX() + "  " + e.getY());

  }
}
