package builder;
import java.awt.event.*;
import java.awt.*;

/**     This class allows a node to change the default actions.
        * @author Dennis Seay 
        * @version 1.1 07/97
*/


public class NodeMouseListener extends MoveableMouseListener
{

/** Constructor
  * creates a mouseListener 
  * @param p is the objected that created the listener.
*/
  public NodeMouseListener(Moveable p)
  {
    super(p);
  }

/* mouseClicked
  * This function handles the case were the right mouse button was clicked
  * the other buttons are handled by the super class.
  * @param e is the event that occured
*/

  public void mouseClicked(MouseEvent e)
  {
    int currentStatus = parent.getMouseStatus();
    if(currentStatus == parent.NORMAL_MOUSE)
    {
      switch(e.getModifiers())
      {  
        case e.META_MASK:
        //case e.BUTTON3_MASK: // This is the same as META_MASK
        {
          ((Node)parent).rightMouseClick(e.getX(),e.getY()); 
          break;
        }
        default:
        {
          super.mouseClicked(e);
          break;
        }
      }  
    }else // Handle unspecified event type
    {
          super.mouseClicked(e);
    }
     
  }

}
