package builder;

import java.awt.*;



/**	Icon in the ToolBar.
	* @author Arturo Falck
	* @author Dennis Seay
	* @version 1.1 07/97
*/
public class ToolIcon extends Moveable {



// ********************* CONSTRUCTORS


/**	Main Constructor.
	* @param l the text of a button on this temporary ToolIcon.
*/
	public ToolIcon (String l){
		super();
		setLayout(new GridLayout(1,1));
		setListener(this);
		Button b = new Button(l);
		b.setActionCommand(l);
		if(l.equals(" "))
		{
			b.setEnabled(false);
		}
		add(b);
	}

/**	Constructor.
*/
	public ToolIcon (){
		this(" ");
	}

/**	Constructor.
	* @param l the text of a button on this temporary ToolIcon.
	* @param al is the ToolBarActionListener for this icon. al handles the
                 events generated by the icon.
*/

	public ToolIcon (String l,ToolBarActionListener al){
		super();
		setLayout(new GridLayout(1,1));
		Button b = new Button(l);
		b.setActionCommand(l);
		b.addActionListener(al);
		add(b);
	}

// ********************* METHODS


/**	paint
	Defines the graphical representation of this Icon.
	* @param g the graphics context.
*/

	public void paint(Graphics g){
		g.setColor(Color.blue);
		g.draw3DRect(1, 1, 28, 27, true);
		g.draw3DRect(1, 1, 27, 28, true);
	}



// ********************* FIELDS


}
