package builder;
import java.awt.event.*;
import java.awt.*;

/** This is the action listener for the menus in Builder
  * @see Builder
  * @author Dennis Seay
  * @version 1.1 07/97
*/


public class WorkSpaceActionListener implements ActionListener
{
  WorkSpace parent = null;
  TextField tField;
  Frame box;
  Button sButton = null;
  static String openName;
  static String saveName;

/**
  * @param p is the parent that the action is to performed on.
*/
  public WorkSpaceActionListener(WorkSpace p)
  {
    parent = p;
  }

  public void saveNow(){
		saveName = tField.getText();
        SaveNodes sp = new SaveNodes(parent.toolbar.flow.nodesVector,parent.toolbar.flow.wiresVector,saveName,parent.parent.fs, parent.parent.ws);
        sp.saveData();
        sp.saveWire();
        sp.saveLocation();
        sp.closeSaveFile();
  }



  public void closeNameWindow(){
	box.setVisible(false);
  }

  public void getNameWindow(String title,String function)
  {
	box = new Frame(title);
	box.setLayout(new GridLayout(2,1));
	Panel p1 = new Panel(new BorderLayout());
	p1.add("West",new Label("Enter File Name: "));
	tField = new TextField("",40);
	tField.addActionListener(this);
	p1.add("East",tField);
	box.add(p1);

	Panel p2 = new Panel(new BorderLayout());
	sButton = new Button(function);
	sButton.addActionListener(this);
	sButton.setActionCommand(function);
	p2.add("West",sButton);
	Button cButton = new Button("Cancel");
	cButton.addActionListener(this);
	cButton.setActionCommand("Cancel");
	p2.add("East",cButton);
	box.add(p2);
	
	box.pack();
	if ((title == "Open") && (openName != null)){
		tField.setText(openName);
	}
	else if (saveName != null){
		tField.setText(saveName);
	}
	box.setVisible(true);
  }


/** This function can create a new project, call the close function or save the project.
  * @param e is the event that occured.
*/
  public void actionPerformed(ActionEvent e)
  {
    if (e.getActionCommand() == "New Project")
    {
      parent.parent.newProject();
    }else if(e.getActionCommand() == "Quit")
    {
      parent.quitWindowHelper();
    }else if(e.getActionCommand() == "Save Project")
    {
      getNameWindow("Save File","Save");
    }else if((e.getActionCommand() == "Save") || 
		(e.getSource() == tField && sButton.getLabel() == "Save"))
    {
      saveNow();
	  closeNameWindow();
    }else if((e.getActionCommand() == "Open") || 
		(e.getSource() == tField && sButton.getLabel() == "Open"))
    {
	  openName = tField.getText();
      parent.parent.loadProj(openName);
	  closeNameWindow();
    }else if(e.getActionCommand() == "Cancel")
    {
      closeNameWindow();
    }else if(e.getActionCommand() == "Open Project...")
    {
      getNameWindow("Open URL","Open");
    }
  }
}
